################################################################################################
#
# Tic Tac Toe Combat
#
################################################################################################


################################################################# General ################################################################

scoreboard objectives add r dummy
scoreboard objectives add ET dummy
scoreboard objectives add ET2 dummy
scoreboard objectives add rc minecraft.used:minecraft.carrot_on_a_stick
scoreboard objectives add sneak minecraft.custom:minecraft.sneak_time
scoreboard objectives add talk minecraft.custom:minecraft.talked_to_villager
scoreboard objectives add walk minecraft.custom:minecraft.walk_one_cm
scoreboard objectives add sprint minecraft.custom:minecraft.sprint_one_cm
scoreboard objectives add crouch minecraft.custom:minecraft.crouch_one_cm
scoreboard objectives add jump minecraft.custom:minecraft.jump
scoreboard objectives add pick_used minecraft.used:minecraft.diamond_pickaxe
scoreboard objectives add x dummy
scoreboard objectives add y dummy
scoreboard objectives add z dummy
scoreboard objectives add dx dummy
scoreboard objectives add dz dummy
scoreboard objectives add dy dummy
scoreboard objectives add turn dummy
scoreboard objectives add f1 dummy
scoreboard objectives add f2 dummy
scoreboard objectives add f3 dummy
scoreboard objectives add f4 dummy
scoreboard objectives add f5 dummy
scoreboard objectives add f6 dummy
scoreboard objectives add f7 dummy
scoreboard objectives add f8 dummy
scoreboard objectives add f9 dummy
scoreboard objectives add input_hover_id dummy
scoreboard objectives add can_click dummy
scoreboard objectives add reset_board_t dummy
scoreboard objectives add draw_timer dummy
scoreboard objectives add timer_level dummy
scoreboard objectives add xp_amount dummy
scoreboard objectives add time_out_timer dummy
scoreboard objectives add attack minecraft.custom:minecraft.damage_dealt

team add nocoll
team modify nocoll collisionRule never
team modify nocoll seeFriendlyInvisibles false

tellraw @a[tag=!init_msg] ["",{"text":"\n\n\n==-=-- TicTacToe Combat - ","color":"red","bold":true},{"text":"by McMakistein","color":"gold","bold":true},{"text":" --=-==","color":"red","bold":true},{"text":"\n                 [","color":"none","bold":false},{"text":"Explanation video about this creation","color":"dark_green","clickEvent":{"action":"open_url","value":"https://youtu.be/HywB97TBksU"}},{"text":"]\n\n","color":"none"},{"text":"                       More of my work:\n","bold":true,"color":"none"},{"text":"                [","bold":false,"color":"none"},{"text":"Youtube","color":"red","bold":true,"clickEvent":{"action":"open_url","value":"https://www.youtube.com/user/McMakistein?sub_confirmation=1."},"hoverEvent":{"action":"show_text","value":{"text":"","extra":[{"text":"Subscribe for more commandblock creation like this!"}]}}},{"text":"] - [","color":"none","bold":false},{"text":"Twitter","color":"blue","bold":true,"clickEvent":{"action":"open_url","value":"https://twitter.com/MrMakistein"},"hoverEvent":{"action":"show_text","value":{"text":"","extra":[{"text":"Follow me on twitter for updates and sneakpeaks on new projects!"}]}}},{"text":"] - [","color":"none","bold":false},{"text":"Instagram","color":"gold","bold":true,"clickEvent":{"action":"open_url","value":"http://instagram.com/mrmakistein"},"hoverEvent":{"action":"show_text","value":{"text":"","extra":[{"text":"Follow me on Instagram if you want to know more about me as a person!"}]}}},{"text":"]","color":"none","bold":false}]
tag @a add init_msg

gamerule logAdminCommands false
gamerule commandBlockOutput false

################################################### General #############################################

team join nocoll @a
effect give @e[tag=invis] minecraft:invisibility 9 9 true

execute as @a at @s run execute as @a[distance=0.1..5] at @s run effect give @a[distance=..5] resistance 1 200 true

execute as @a at @s positioned ^ ^ ^1.9 if entity @a[nbt={HurtTime:10s},distance=..1.89,limit=1] run tag @s add attacker
execute as @a at @s positioned ^ ^ ^1.9 run tag @a[nbt={HurtTime:10s},distance=..1.89,limit=1] add attacked

execute as @e[tag=attacker] at @s align xyz run summon armor_stand ~0.5 ~0.5 ~0.5 {Tags:[ttt_spawn]}


################################################### Game Init #############################################

execute as @e[tag=ttt_spawn] at @s run function tictactoe_combat:init_board
tag @a[tag=attacker] remove attacker
tag @a[tag=attacked] remove attacked


################################################### Game End #############################################

execute as @e[tag=ttt,tag=reset] at @s run function tictactoe_combat:end_game


################################################### Input Hover ID #############################################
execute as @e[tag=ttt,scores={turn=0}] at @s positioned ~ ~-1 ~2 run execute as @a[tag=player1,distance=..1,limit=1,sort=nearest] at @s run function tictactoe_combat:input_hover_id_player1
execute as @e[tag=ttt,scores={turn=1}] at @s positioned ~ ~-1 ~-2 run execute as @a[tag=player2,distance=..1,limit=1,sort=nearest] at @s run function tictactoe_combat:input_hover_id_player2

################################################### Turn Display #############################################

execute as @e[tag=ttt,scores={turn=0}] at @s positioned ~ ~-1 ~2 run execute as @a[tag=player1,distance=..1,limit=1,sort=nearest] at @s run title @s actionbar {"text":"Your turn!","color":"dark_green","bold":"true"}
execute as @e[tag=ttt,scores={turn=0}] at @s positioned ~ ~-1 ~-2 run execute as @a[tag=player2,distance=..1,limit=1,sort=nearest] at @s run title @s actionbar {"text":"Opponents turn!","color":"red","bold":"true"}

execute as @e[tag=ttt,scores={turn=1}] at @s positioned ~ ~-1 ~-2 run execute as @a[tag=player2,distance=..1,limit=1,sort=nearest] at @s run title @s actionbar {"text":"Your turn!","color":"dark_green","bold":"true"}
execute as @e[tag=ttt,scores={turn=1}] at @s positioned ~ ~-1 ~2 run execute as @a[tag=player1,distance=..1,limit=1,sort=nearest] at @s run title @s actionbar {"text":"Opponents turn!","color":"red","bold":"true"}

################################################### Game Running #############################################

scoreboard players add @a can_click 0
scoreboard players remove @a[scores={can_click=1..}] can_click 1
effect give @a[tag=active_player] resistance 200 1 true
execute as @e[tag=ttt] at @s positioned ~ ~-1.5 ~2 run tp @a[tag=player1,tag=active_player,limit=1,sort=nearest] ~ ~ ~
execute as @e[tag=ttt] at @s positioned ~ ~-1.5 ~-2 run tp @a[tag=player2,tag=active_player,limit=1,sort=nearest] ~ ~ ~

execute as @e[tag=ttt] at @s run effect give @a[tag=active_player,limit=2,sort=nearest] levitation 1 255 true


execute as @e[tag=ttt,scores={turn=0,time_out_timer=0}] at @s positioned ~ ~-1 ~2 run execute as @a[tag=active_player,tag=player1,scores={talk=1..,can_click=0},distance=..1,limit=1,sort=nearest] at @s run function tictactoe_combat:click_player1
execute as @e[tag=ttt,scores={turn=1,time_out_timer=0}] at @s positioned ~ ~-1 ~-2 run execute as @a[tag=active_player,tag=player2,scores={talk=1..,can_click=0},distance=..1,limit=1,sort=nearest] at @s run function tictactoe_combat:click_player2

execute as @e[tag=ttt,scores={f1=1..,f2=1..,f3=1..,f4=1..,f5=1..,f6=1..,f7=1..,f8=1..,f9=1..,turn=0..1,draw_timer=0,time_out_timer=0,reset_board_t=0}] at @s run function tictactoe_combat:end_round

scoreboard players remove @e[scores={reset_board_t=1..}] reset_board_t 1
execute as @e[tag=ttt,scores={reset_board_t=1}] at @s run tag @s add reset
scoreboard players add @e[tag=ttt] reset_board_t 0

scoreboard players add @e[tag=ttt] draw_timer 0
scoreboard players remove @e[scores={draw_timer=1..}] draw_timer 1
execute as @e[tag=ttt,scores={draw_timer=1}] at @s run function tictactoe_combat:reset_board

execute as @e[tag=ttt,scores={turn=0,time_out_timer=0,draw_timer=0,reset_board_t=0}] at @s run execute as @e[tag=active_player,tag=player1] at @s run scoreboard players remove @s xp_amount 1
execute as @e[tag=ttt,scores={turn=0,time_out_timer=0,draw_timer=0,reset_board_t=0}] at @s run execute as @e[tag=active_player,tag=player1] at @s run xp add @s -1 points
execute as @e[tag=ttt,scores={turn=1,time_out_timer=0,draw_timer=0,reset_board_t=0}] at @s run execute as @e[tag=active_player,tag=player2] at @s run scoreboard players remove @s xp_amount 1
execute as @e[tag=ttt,scores={turn=1,time_out_timer=0,draw_timer=0,reset_board_t=0}] at @s run execute as @e[tag=active_player,tag=player2] at @s run xp add @s -1 points
execute as @a[tag=active_player,scores={xp_amount=..0}] at @s run scoreboard players set @e[tag=ttt,distance=..3,limit=1,sort=nearest,scores={time_out_timer=0,draw_timer=0,reset_board_t=0}] time_out_timer 40
xp set @a[tag=active_player,scores={timer_level=0}] 30 levels
xp set @a[tag=active_player,scores={timer_level=1}] 25 levels
xp set @a[tag=active_player,scores={timer_level=2}] 20 levels
xp set @a[tag=active_player,scores={timer_level=3}] 15 levels
xp set @a[tag=active_player,scores={timer_level=4}] 7 levels


scoreboard players add @e[tag=ttt] time_out_timer 0
scoreboard players remove @e[scores={time_out_timer=1..}] time_out_timer 1
execute as @e[tag=ttt,scores={time_out_timer=1}] at @s run tag @s add reset
execute as @e[tag=ttt,scores={time_out_timer=1}] at @s run function tictactoe_combat:end_game
scoreboard players set @e[tag=ttt,scores={time_out_timer=35}] time_out_timer 20
execute as @e[tag=ttt,scores={time_out_timer=38,turn=0}] at @s run title @a[tag=player1,distance=..3,limit=1,sort=nearest] title {"text":"Defeat","color":"red"}
execute as @e[tag=ttt,scores={time_out_timer=38,turn=0}] at @s run title @a[tag=player1,distance=..3,limit=1,sort=nearest] subtitle {"text":"You timed out","color":"white"}
execute as @e[tag=ttt,scores={time_out_timer=38,turn=0}] at @s run title @a[tag=player2,distance=..3,limit=1,sort=nearest] title {"text":"Won","color":"green"}
execute as @e[tag=ttt,scores={time_out_timer=38,turn=0}] at @s run title @a[tag=player2,distance=..3,limit=1,sort=nearest] subtitle {"text":"Opponent timed out","color":"white"}
execute as @e[tag=ttt,scores={time_out_timer=38,turn=0}] at @s run effect clear @a[tag=player1,distance=..3,limit=1,sort=nearest] resistance
execute as @e[tag=ttt,scores={time_out_timer=38,turn=0}] at @s run effect give @a[tag=player1,distance=..3,limit=1,sort=nearest] instant_damage 1 0 true

execute as @e[tag=ttt,scores={time_out_timer=38,turn=1}] at @s run title @a[tag=player2,distance=..3,limit=1,sort=nearest] title {"text":"Defeat","color":"red"}
execute as @e[tag=ttt,scores={time_out_timer=38,turn=1}] at @s run title @a[tag=player2,distance=..3,limit=1,sort=nearest] subtitle {"text":"You timed out","color":"white"}
execute as @e[tag=ttt,scores={time_out_timer=38,turn=1}] at @s run title @a[tag=player1,distance=..3,limit=1,sort=nearest] title {"text":"Won","color":"green"}
execute as @e[tag=ttt,scores={time_out_timer=38,turn=1}] at @s run title @a[tag=player1,distance=..3,limit=1,sort=nearest] subtitle {"text":"Opponent timed out","color":"white"}
execute as @e[tag=ttt,scores={time_out_timer=38,turn=1}] at @s run effect clear @a[tag=player2,distance=..3,limit=1,sort=nearest] resistance
execute as @e[tag=ttt,scores={time_out_timer=38,turn=1}] at @s run effect give @a[tag=player2,distance=..3,limit=1,sort=nearest] instant_damage 1 0 true

execute as @e[tag=ttt,scores={time_out_timer=38}] at @s run title @a[tag=active_player,distance=..3,limit=1,sort=nearest] times 5 15 10




################################################### Init RC Msg #############################################

execute as @e[tag=ttt,scores={turn=0}] at @s run title @a[tag=player1,tag=rc_init_msg,distance=..3,limit=1,sort=nearest] title {"text":"","color":"red"}
execute as @e[tag=ttt,scores={turn=0}] at @s run title @a[tag=player1,tag=rc_init_msg,distance=..3,limit=1,sort=nearest] subtitle {"text":"Rightclick to place!","color":"gray"}
execute as @e[tag=ttt,scores={turn=0}] at @s run title @a[tag=player1,tag=rc_init_msg,distance=..3,limit=1,sort=nearest] times 2 15 5
execute as @e[tag=ttt,scores={turn=0}] at @s run tag @a[tag=player1,tag=rc_init_msg,distance=..3,limit=1,sort=nearest] remove rc_init_msg

execute as @e[tag=ttt,scores={turn=1}] at @s run title @a[tag=player2,tag=rc_init_msg,distance=..3,limit=1,sort=nearest] title {"text":"","color":"red"}
execute as @e[tag=ttt,scores={turn=1}] at @s run title @a[tag=player2,tag=rc_init_msg,distance=..3,limit=1,sort=nearest] subtitle {"text":"Rightclick to place!","color":"gray"}
execute as @e[tag=ttt,scores={turn=1}] at @s run title @a[tag=player2,tag=rc_init_msg,distance=..3,limit=1,sort=nearest] times 2 15 5
execute as @e[tag=ttt,scores={turn=1}] at @s run tag @a[tag=player2,tag=rc_init_msg,distance=..3,limit=1,sort=nearest] remove rc_init_msg





################################################################################################################




tag @a remove give
scoreboard players set @a talk 0
scoreboard players set @a sneak 0
scoreboard players set @a jump 0
scoreboard players set @a rc 0
scoreboard players set @a pick_used 0
